from passenger import Passenger

# INSERT YOUR CODE AFTER THIS LINE

class Flight(object):
  '''Flight class
  '''
  def __init__(self,fn,ps=None):
    '''make a flight with a number.  there are optional passengers list
    '''
    try:
      if ps == None:
        self.ps = []
      else:
        self.ps = ps
      if type(fn) == str:
         fn = int(fn)
      self.fn = fn
    except:
      print "couldn't make flight"

  def add_passenger(self,new_ps):
    '''add passenger to flight
    '''
    try:
      self.ps.insert(0,new_ps)
    except:
      print "couldn't add passenger"

  def __str__(self):
    '''return the str representation of this flight
    '''
    try:
      s_ps = [str(p) for p in self.ps]
      no_passengers = False
      if len(s_ps) == 0:
        no_passengers = True
      f_str = "Flight #" + str(self.fn)
      f_str += "\n-----------------------------\n"
      if no_passengers == True:
        f_str += "No passengers"
        return f_str
      else:
        f_str += '\n'.join(s_ps)
        return f_str
    except:
      print "couldn't use __str__"

  def heaviest_passenger(self):
    '''return the heaviest passenger
    '''
    try:
      max_luggage = 0
      max_p = None
      for p in self.ps:
        lug_sum = get_luggage_sum(p)
        if lug_sum > max_luggage:
          max_p = p
          max_luggage = lug_sum
      return max_p
    except:
      print "couldn't use heaviest_passenger"

  def lightest_passenger(self):
    '''return the lightest passenger
    '''
    try:
      max_luggage = 100
      max_p = None
      for p in self.ps:
        lug_sum = get_luggage_sum(p)
        if lug_sum < max_luggage:
          max_p = p
          max_luggage = lug_sum
      return max_p
    except:
      print "couldn't use lightest_passenger"



def get_luggage_sum(p):
  total = 0
  for l in p.suitcase_weights:
    total += int(l)
  return total
 
# INSERT YOUR CODE BEFORE THIS LINE

# And here's some code to test out your implementation.  You can change this if you'd like.
if __name__ == "__main__":
  f = Flight(1)
  print f
  p1 = Passenger('Amelia', [5.2,1.2,8.2,1.0], 'business')
  f.add_passenger(p1)
  print f
  
  p2 = Passenger('Harvey', [9.1,29.2,3.2,1.7], 'economy')
  f.add_passenger(p2)
  print f

  print "Heaviest passenger: "
  print f.heaviest_passenger()

  print "Lightest passenger: "
  print f.lightest_passenger()
