from passenger import Passenger

# INSERT YOUR CODE AFTER THIS LINE
class Flight(object):
  '''Class Flight provides a method "add_passenger" that will add a passenger
     to the flight.  Also has a constructor and a __str__, and heaviest_passenger
     and lightest_passenger methods.
   '''

  def __init__(self,num,ps=None):
    '''Initialize Flght with num and ps'''
    self._num = str(num)
    self._ps = ps
    if self._ps == None:
      self._ps = []
    self._passengers = []

  def add_passenger(self,p):
    '''Add a passenger to the Flight'''
    self._passengers.append(p)

  def __str__(self):
    '''Prints out the string'''
    print "Flight #" + self._num
    print "--------------------------"
    if len(self._passengers) == 0:
      print "No passengers"
    elif len(self._passengers) > 0:
      for p in self._passengers:
         print p.name + ", flying " + p.ticket_type + "(",
         for i in p.suitcase_weights:
           print str(i) + ",",
         print ")"

  def heaviest_passenger(self):
    ''' Returns the heaviest passenger'''
    heaviest = 0
    done = None
    for p in self._passengers:
      total = 0
      for i in p.suitcase_weights:
        # print "HERE " + total
        total = total + i
      if total < heaviest:
        heaviest = total
        done = p
    return done
    
  def lightest_passenger(self):
    ''' Returns the lightest passenger'''
    heaviest = 0
    done = None
    for p in self._passengers:
      total = 0
      for i in p.suitcase_weights:
        # print "HERE " + total
        total = total + i
      if total > heaviest:
        heaviest = total
        done = p
    return done

# INSERT YOUR CODE BEFORE THIS LINE

# And here's some code to test out your implementation.  You can change this if you'd like.
if __name__ == "__main__":
  f = Flight(1)
  p1 = Passenger('Amelia', [5.2,1.2,8.2,1.0], 'business')
  f.add_passenger(p1)
  #print f
#
  #f2 = Flight(2,p1)  d
  f3 = Flight(2,[p1])  

  p2 = Passenger('Harvey', [9.1,29.2,3.2,1.7], 'economy')
  f.add_passenger(p2)
#  print f

  print "Heaviest passenger: "
  print f.heaviest_passenger()

  print "Lightest passenger: "
  print f.lightest_passenger()
