from passenger import Passenger

# INSERT YOUR CODE AFTER THIS LINE

class Flight(object):
  """A flight with passenger objects"""
  def __init__(self, x, y=None):
    self.flight_n = str(x)
    if y == None or type(y) != list:
      y = []
    self.aboard = y
  def __str__(self):
    out_str = ''
    for x in self.aboard:
      out_str += str(x) + '\n'
    output = 'Flight number ' + self.flight_n + '\n'

    output += "\n-------------------\n"
    if out_str == '':
      output += '\nNo passengers\n'
    else:
      output += out_str
    return output

  def add_passenger(self, x):
    self.aboard.insert(len(self.aboard),x)

  def heaviest_passenger(self):
    for x in self.aboard:
      if self.check_heaviest(x) == True:
        return x

  def check_heaviest(self, check):
    heaviest = True
    for x in self.aboard:
      if x.suitcase_weights > check.suitcase_weights:
        heaviest = False
    return heaviest

  def lightest_passenger(self):
    for x in self.aboard:
      if self.check_lightest(x) == True:
        return x

  def check_lightest(self, check):
    lightest = True
    for x in self.aboard:
      if x.suitcase_weights < check.suitcase_weights:
        lightest = False
    return lightest

# INSERT YOUR CODE BEFORE THIS LINE

# And here's some code to test out your implementation.  You can change this if you'd like.
if __name__ == "__main__":
  p1 = Passenger('Amelia', [5.2,1.2,8.2,1.0], 'business')
  f = Flight(1, [p1])
  f.add_passenger(p1)
#  print f
  
  p2 = Passenger('Harvey', [9.1,29.2,3.2,1.7], 'economy')
  f.add_passenger(p2)
  print f

  print "Heaviest passenger: "
  print f.heaviest_passenger()

  print "Lightest passenger: "
  print f.lightest_passenger()
