from passenger import Passenger

# INSERT YOUR CODE AFTER THIS LINE

class Flight(object):
	"""This class models passengers flying on an airplane.  Flights can have
	flight numbers, and passengers, and passengers can be added to the Flight.
	Flights can also have heaviest and lightest passengers with heaviest_passenger
	and lightest_passenger
	"""
	def __init__(self, flight_number, list_of_passengers):	
		"""This method initializes the Flight, adding the flight number and to
		the list of passengers"""
		# set the internal flight number to flight number
		self.internal_flight_number = flight_number
		# set the internal list of passengers to list of passengers
		self.internal_list_of_passengers = list_of_passengers

	def add_passenger(self, passenger_to_be_added):
		"""This method adds the passenger passenger_to_be_added to the list
		of passengers"""
		# add the passenger by appending it to the internal_list_of_passengers 
		#list
		self.internal_list_of_passengers.append(passenger_to_be_added)
	
	def __str__(self):
		"""this method allows me to print out the flight passengers as a string
		so that we can inside of it"""	
		# final is the name of the string to return to the caller
		final = str()
		# use one variable to go through the internal_list_of_passengers
		a = 0
		# add the flight number to final
 		final = final + "Flight No. " + str(self.internal_flight_number) + "\n"
		# add the line
		final = final + "-----------------------" + "\n"
		if len(self.internal_list_of_passengers) == 0:
			final = final + "No passengers" + "\n"
		else:
			while(a < len(self.internal_list_of_passengers)):
			# each time i go through the loop, add the passenger string to final
				final = final + str(self.internal_list_of_passengers[a]) + "\n"
				# add one to a
				a = a + 1
		return final

	def heaviest_passenger(self):
		"""this method returns the heaviest passenger on the airplane"""
		# use one variable to go through the internal_list_of_passengers
		a = 0
		# store the final passenger
		final_passenger = None
		# go through the internal_list_of_passengers
		while(a < len(self.internal_list_of_passengers)):
			passenger = self.internal_list_of_passengers[a]
			# now see if this passenger is heavier than all other
			# passengers
			# use one variable to go through the internal_list_of_passengers
			b = 0
			found_heavier = False
			while(b < len(self.internal_list_of_passengers)):
				new_passenger = self.internal_list_of_passengers[b]
				final_passenger = new_passenger
				if self.get_suitcase_weight(new_passenger) > \
					self.get_suitcase_weight(passenger):
					# we found a heavier one
					found_heavier = True
					break;

				# add one to b
				b = b + 1
			if found_heavier == False:
				return final_passenger
			# add one to a
			a = a + 1


	def get_suitcase_weight(self, passenger):
		"""this method returns the weight of a passengers suitcases"""
		# use one variable to go through the passengers suitcases
		a = 0
		# store the total	
		total = 0
		while(a < len(passenger.suitcase_weights)):
			# add the weight to the total
			total = total + passenger.suitcase_weights[a]
			# add one to a
			a = a + 1
		return total


	def lightest_passenger(self):
		"""this method returns the heaviest passenger on the airplane"""
		# use one variable to go through the internal_list_of_passengers
		a = 0
		# store the final passenger
		final_passenger = None
		# go through the internal_list_of_passengers
		while(a < len(self.internal_list_of_passengers)):
			passenger = self.internal_list_of_passengers[a]
			# now see if this passenger is heavier than all other
			# passengers
			# use one variable to go through the internal_list_of_passengers
			b = 0
			found_lighter = False
			while(b < len(self.internal_list_of_passengers)):
				new_passenger = self.internal_list_of_passengers[b]
				final_passenger = new_passenger
				if self.get_suitcase_weight(new_passenger) < \
					self.get_suitcase_weight(passenger):
					# we found a heavier one
					found_lighter = True
					break;

				# add one to b
				b = b + 1
			if found_lighter == False:
				return final_passenger
			# add one to a
			a = a + 1


# INSERT YOUR CODE BEFORE THIS LINE

# And here's some code to test out your implementation.  You can change this if you'd like.
if __name__ == "__main__":
#  f = Flight(1)  
  f = Flight(1,[])
  p1 = Passenger('Amelia', [5.2,1.2,8.2,1.0], 'business')
  f.add_passenger(p1)
  print f
  
  p2 = Passenger('Harvey', [9.1,29.2,3.2,1.7], 'economy')
  f.add_passenger(p2)
  print f

  print "Heaviest passenger: "
  print f.heaviest_passenger()

  print "Lightest passenger: "
  print f.lightest_passenger()
